\label{chap:fwork}

\noindent
This report shows transformation correctness with many test cases. Showing
correctness may be not enough under certain circumstances, principally if
the transformation is used in Model Checking to test code statements reached 
and not reached. For instance, one can never be sure if a statement is not
reached because of an incorrect transformation i.e., a misplaced instruction or
wrong register numbering. Note, that the Java Virtual Machine has also failures.
Any release is not only an attempt to improve efficiency but also to fix many of 
them. Nevertheless, one can be sure of transformation correctness if a kind of 
prove can be presented. This prove can certainly be only so good as the java 
program itself since Java bytecode, is the measure of correctness used.\\
At the research of a prove for transformation correctness, the interpreter may be
improved on many topics. Many of them are very important, others are just desirable.

%========================================================================*/

\section{Important topics}
To improve interpreter performance and to get closer to a prove rather than
a test, there are many salient points which may be corrected as soon as possible.

\subsection*{Class loader}
\index{class!loading}~\label{ref:classloader}
The problem of loading classes is not a trivial task. To achieve efficiency,
classes may be loaded only if they are used. There are also many classes
dependencies to be solved at initialization time. For instance, static classes
may be initialized before program execution starts. The current interpreter
can load classes only manually i.e., it reads classes from a vector, not from
a specific directory.

\subsection*{Native methods}
\index{native}
The current interpreter implementation supports only two native methods calls:
\emph{intBitstoFloat} and \emph{longBitsToDouble}. Both methods are used for
representing numbers within a print context. This explicit implementation
is not always possible or desirable. A better way to resolve native methods
calls may be found. The CACAO implementation may help on the research of
solutions for this problem. See section~\ref{ref:cacao} on page~\pageref{ref:cacao}.

\subsection*{Multithreading}
\index{Multithreading}
To avoid memory access conflicts and achieve efficiency, virtual machines may
support multithreading. The current interpreter provides only the basic
implementation for the \texttt{MonitorEnter} and \texttt{MonitorExit} instructions
and may be extended with more sophisticated multithreading algorithms.

\subsection*{Unicode}
\index{unicode}
Invocating the Java String class or the Java Character class may produce several
problems. This Java classes use internally an unicode conversion. The framework
supports only partially unicode conversions eg the method \texttt{UCSString}.
Conversions of strings to numbers does not work and must be done.

\subsection*{Overhead}
\index{overhead}
The interpreter may produce time and memory overhead. Time overhead comes up
while using the \texttt{strcmp} method. Strategies for method identification
may be found. Memory overhead is produced when objects are unnecessarily cloned.
A better object manipulation may be done.

%========================================================================*/

\section{Desirable topics}
Desirable topics include problems which can be solved in a second phase of
problem handling. Their contribution for the transformation prove is more
of support rather than approach character.

\subsection*{NullPointerExceptions}
The current interpreter handles NullPointerExceptions but, it does not stop
always the virtual machine. Once the class loader problem was resolved
(see section~\ref{ref:classloader} on page~\pageref{ref:classloader}),
all NullPointerExceptions occurrences may consequently stop the virtual machine.
\index{NullPointerException}

\subsection*{JNukeFrame}
Any time a context switch occurs, the current register map is stored onto
the register stack and a new one is created. When the callee returns,
the last created register map is discarded and the old one restored. To restore
the registers, the method \texttt{JNukeFrame\_pop} is invoked. This method raises
an assertion error.
\index{JNukeFrame}

\subsection*{Booleans}
The instructions of type \texttt{ifcmp} use an integer to pass condition information.
This is essentially correct but, to be Java compatible, the boolean type information
should be also passed. The transformation looses this information.
\index{Boolean}

\subsection*{Numbers frontier}
The exact representation of \texttt{infinity} and \texttt{NaN} for all floating
point types on different platforms and virtual machines may be investigated.

\subsection*{Stand alone application}
Loading classes dynamically can lead to separate the current interpreter from the
framework i.e., as a stand alone application. The interpreter gains more flexibility
with this separation. After that separation, testing a set of optimizations in one
go i.e., sequentially may be possible.
\index{application}
\index{stand alone}

\subsection*{Interface inheritance}
The current interpreter supports class inheritance. Interface inheritance is only
supported on a first level i.e., the functionality obtained through multiple level
inheritance must be made.
\index{interfaces}

\subsubsection*{Print method}
If the interpreter has to print floating point numbers, several problems may occur concerning
the number of decimal used. To be Java conform, it may be necessary to C re-write the Java
\emph{FloatingDecimal} class.
\index{class!FloatingDecimal}

\subsection*{Explicit State Model Checker}
\index{Explicit State Model Checker@|textbf}
One of the advantages of the Register Based Bytecode Transformation is the simplified
construction of an \emph{Explicit State Model Checker}, a virtual machine which goes through
all possible paths of a given control flow graph looking if all nodes visited and states reached
are allowed or not~\cite{bib:path}. For that purpose, one may use a set of C classes with statistic
behavior. These C classes may register, if certain graph paths are visited or not.
A registration can be done saving the current state. Also a low memory footprint may support
this task.

\subsection*{Running tests}
Any time a test case is invoked, a new interpreter instance is created and initialized. Afterwards,
bytecode execution can begin. This starting way may be slow, principally if the user intends
to run many test cases sequentially. For that purpose, the interpreter can be modified to create
only on execution entity, gaining execution time and avoiding memory overhead.

\section{Optimizations}
\index{Optimizations}
The current interpreter may gain efficiency, if the transformation replaces linear loops
in vectors by hash tables. The costs for accessing data may sink. \\
Another optimization possibility is the elimination of unused registers. Such unused 
registers occur when an instruction for double words is invoked, eg a double word
operation. A double word should occupy one 64 bit register rather than two 32 bit 
registers. \\
As the optimization algorithm written by Pascal Eugster~\cite{bib:pascal} as the interpreter
may be improved to be compatible during double word operations.

\section{Summary}
This chapter distinguishes between two kinds of future work and optimizations. Certain
problems may be handled as soon as possible since they are essential to achieve more 
interpretation efficiency. They are also a milestone on the long way at the research
for a prove for transformation correctness. Other problems are less important but
desirable. They may support results interpretation rather than a transformation prove.
Many of them are very hard to realize as the \emph{print} method.

